import { FormBuilder, FormGroup, AbstractControl, AbstractControlOptions } from '@angular/forms';
export declare type FormGroupControl = string | number | [] | [string | number] | [string | number, [any]] | any;
export interface ISafeFormGroup<I, T = Required<I>> extends Omit<FormGroup, 'controls' | 'patchValue' | 'get'> {
    controls: {
        [P in keyof T]: AbstractControl;
    };
    patchValue(value: {
        [P in keyof Partial<I>]: FormGroupControl;
    }, options?: {
        onlySelf?: boolean;
        emitEvent?: boolean;
    }): void;
    setValue(value: {
        [P in keyof Partial<I>]: FormGroupControl;
    }, options?: {
        onlySelf?: boolean;
        emitEvent?: boolean;
    }): void;
    get(path: Array<keyof T> | keyof T): AbstractControl;
}
export interface ITypeSafeFormBuilder extends Omit<FormBuilder, 'group'> {
    group<T, I = Required<T>>(controlsConfig: {
        [key in keyof I]: any;
    }, options?: AbstractControlOptions | {
        [key: string]: any;
    } | null | undefined): FormGroup;
}
export declare class NgxTypedFormBuilder extends FormBuilder implements ITypeSafeFormBuilder {
    fb: FormBuilder;
    constructor(fb: FormBuilder);
    typeSafeGroup<T, I = Required<T>>(controlsConfig: {
        [key in keyof I]: boolean | string | number | undefined | [] | [boolean | string | number | undefined | undefined] | [boolean | string | number | undefined, any[]];
    }, options?: AbstractControlOptions | {
        [key: string]: any;
    } | null | undefined): ISafeFormGroup<T, Required<T>>;
}
